// Button Array test
//********************************************************************
//* HHE-142 Button Array Test
//* Modifications by JG1CCL W3CCL Ver.1.00-1R0 May 5,2023
//* ESP32-S3(ESP32-1732S01)
//*   by JG1CCL W3CCL Beard UCHIDA CCLab(Rabbit Hat Design)
//* Uses buttonarray Internal Library (contributed by W6IPA)
//*   https://github.com/k3ng/k3ng_cw_keyer
//*   I would like to thank W6IPA.
//********************************************************************

#include "buttonarray.h"

// Update HHE-142 Button Array by JG1CCL W3CCL
//#define ARRAY_PIN A3    // Comment out HHE-142 by JG1CCL W3CCL
//#define NB_BUTTONS 2    // Comment out HHE-142 by JG1CCL W3CCL
//#define ENCODER_PIN A1  // Comment out HHE-142 by JG1CCL W3CCL
#define ARRAY_PIN 4   // GPIO4
#define NB_BUTTONS 5  // 5 Buttons(0-4)
#define ENCODER_PIN 5 // GPIO5
// Add HHE-142 by JG1CCL W3CCL
//#define ARDUINO_ARCH_ESP32  // ESP32-S3(ESP32-1732S01) by JG1CCL W3CCL

//int button_array_high_limit[NB_BUTTONS];  // Comment out HHE-142 by JG1CCL W3CCL
//int button_array_low_limit[NB_BUTTONS];   // Comment out HHE-142 by JG1CCL W3CCL
long button_depress_time;

ButtonArray button_array(ARRAY_PIN, NB_BUTTONS, false);
//ButtonArray encoder(ENCODER_PIN, 1, false); // Comment out HHE-142 by JG1CCL W3CCL

void setup() {
  Serial.begin(115200);
  delay(1000); 
  button_array.AddAll();
  //encoder.AddAll(); // Comment out HHE-142 by JG1CCL W3CCL
}

void loop() {
  int analogbuttontemp = button_array.Pressed();
  //if (encoder.Pressed() == 0) {         // Comment out HHE-142 by JG1CCL W3CCL
    //Serial.println("encoder pressed "); // Comment out HHE-142 by JG1CCL W3CCL
  //}                                     // Comment out HHE-142 by JG1CCL W3CCL

  if (analogbuttontemp >= 0) {
    // button pressed.
    button_depress_time = button_array.last_pressed_ms;

    while (button_array.Held(analogbuttontemp, button_depress_time + 1000)) {}
    if (millis() - button_depress_time  < 400) {
      Serial.print("button pressed ");
      Serial.println(analogbuttontemp);
    } else {
      Serial.print("button ");
      Serial.print(analogbuttontemp);
      //Serial.print(" held for ");                     // Comment out HHE-142 by JG1CCL W3CCL
      //Serial.println(millis() - button_depress_time); // Comment out HHE-142 by JG1CCL W3CCL
    }
    Serial.print(" held for ");                         // Add HHE-142 by JG1CCL W3CCL
    Serial.println(millis() - button_depress_time);     // Add HHE-142 by JG1CCL W3CCL
  }
}